###############################################################################
#                                                                             #
#   NL2ARGUS.AWK                                                              #
#                                                                             #
#   AWK script to build an ARGUS.TXT address list file from nodelist file.    #
#   Created by Bob Swift, 1:342/5, on 2002-02-24.                             #
#                                                                             #
###############################################################################


###############################################################################
########                 Initialize the variables                      ########
###############################################################################

BEGIN {

    FS = ",";   # Change the field separater to a comma

    z = 0;      # Initialize Zone
    h = 0;      # Initialize Net
    n = 0;      # Initialize Node

    };

###############################################################################
########          Loop through the lines in the nodelist               ########
###############################################################################

NF > 7 {

    a = "";     # Initialize Address
    f = "";     # Initialize Flag List
    t = "";     # Initialize Temporary Flag List
    c = 0;      # Initialize IP Flag

    if ($1 == "Zone") {
        z = $2;
        h = z;
        n = 0;
        }
    else {
        if ($1 == "Host" || $1 == "Region") {
            h = $2;
            n = 0;
            }
        else {
            n = $2
            }
        }
    g = NF + 1;
    for (i=8; i<g; i++) {
        if ($i == "CM")           {t = t "M";}
        if ($i ~ /BINKD|BND|IBN/) {t = t "B";
            c = 1;
            if ($i ~ /[:]/) {
                b = split($i,d,":");
                if (d[2] ~ /[.]/) {
                    if (d[2] ~ /[a-zA-Z]/) {
                        a = d[2];
                        }
                    else {
                        b = split(d[2],ip,".");
                        a = sprintf("%d%s%d%s%d%s%d",int(ip[1]),".",int(ip[2]),".",int(ip[3]),".",int(ip[4]));
                        }
                    }
                }
            }
        if ($i ~ /TEL|ITN/)       {t = t "T"; c = 1;}
        if ($i ~ /TCP|IP/)        {t = t "I";}
        if ($i ~ /IFC/)           {t = t "C"; c = 1;}
        }

    if (c == 1) {
        if (t ~ /M/) {f = ",CM"};
        if (t ~ /B/) {f = f ",BND,IBN"};
        if (t ~ /T/) {f = f ",TEL,ITN"};
        if (t ~ /I/) {f = f ",TCP,IP"};
        if (t ~ /C/) {f = f ",IFC"};

        if (a == "" && ($6 ~ /000-[0-9]+-[0-9]+-[0-9]+-[0-9]+/)) {
            i = split($6,ip,"-");
            a = sprintf("%d%s%d%s%d%s%d",int(ip[2]),".",int(ip[3]),".",int(ip[4]),".",int(ip[5]));
            }
        if (a == "" && ($3 ~ /[.]/)) {
            a = $3
            }
        if (a ~ /[a-zA-Z]/) {
            a = "\"" a "\""
            }
        if (a ~ /[@]/ || a == "0.0.0.0" || a ~ /_/) {
            a = ""
            }
        if (a != "") {
            print z ":" h "/" n "|" a f
            }
        }
    }; # End of NF > 7


